import { world, EquipmentSlot, system } from "@minecraft/server";

world.afterEvents.itemUse.subscribe((arg) => {
  const { itemStack, source } = arg;

  // Check if the item used is a totem of undying or a shield
  if (
    (itemStack.typeId === "minecraft:totem_of_undying" ||
    itemStack.typeId === "minecraft:shield") &&
	world.getDynamicProperty("swap") === true
  ) {
    // Get the equippable component
    const equippable = source.getComponent("minecraft:equippable");
    if (!equippable) return;

    // Retrieve items from mainhand and offhand slots
    const offhandItem = equippable.getEquipment(EquipmentSlot.Offhand);
    const mainhandItem = equippable.getEquipment(EquipmentSlot.Mainhand);
	if (!offhandItem && (mainhandItem.typeId === "minecraft:totem_of_undying" || mainhandItem.typeId === "minecraft:shield")) {
		equippable.setEquipment(EquipmentSlot.Offhand, mainhandItem);
		equippable.setEquipment(EquipmentSlot.Mainhand, offhandItem);
		source.playSound("armor.equip_generic");
		return;
	}
	if ((offhandItem.typeId === "minecraft:totem_of_undying" || offhandItem.typeId === "minecraft:shield") && (mainhandItem.typeId === "minecraft:totem_of_undying" || mainhandItem.typeId === "minecraft:shield")) {
    equippable.setEquipment(EquipmentSlot.Offhand, mainhandItem);
    equippable.setEquipment(EquipmentSlot.Mainhand, offhandItem);
	source.playSound("armor.equip_generic");
	}
  }
});
