import { world } from "@minecraft/server";

world.afterEvents.itemUseOn.subscribe(({ block, source, itemStack }) => {
  if (itemStack.typeId === "minecraft:string" && world.getDynamicProperty("dupe") === true && Math.random() * 0.8) {
    source.runCommandAsync(`give @s string 1`);
  }

  if (!block) return;

  const dimension = block.dimension; // Get the dimension
  const location = block.location; // Get the location of the block

  if (itemStack.typeId === "minecraft:water_bucket" && block.typeId === "minecraft:web" && world.getDynamicProperty("old_web") === true && source.dimension.id !== "minecraft:nether") {
    dimension.runCommandAsync(`setblock ${location.x} ${location.y} ${location.z} air`);
  }

  // Check if the item used is a water bucket and the block is a web
  if (itemStack.typeId === "minecraft:water_bucket" && block.typeId === "minecraft:web" && world.getDynamicProperty("web") === true && source.dimension.id !== "minecraft:nether") {
    const blockType = block.typeId;

    // Replace the web with flowing water and air
    dimension.runCommandAsync(`setblock ${location.x} ${location.y + 1} ${location.z} flowing_water`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y} ${location.z} air`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y} ${location.z} air`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y} ${location.z} ${blockType}`);
  }

  // Check if the item used is a door
  if (itemStack.typeId.includes("_door") && !block.typeId.includes("_door") && world.getDynamicProperty("door") === true) {
    // Calculate the facing direction of the player
    const sourceViewDirection = source.getViewDirection();

    // Determine the facing direction based on the player's view direction
    const direction = (() => {
      if (Math.abs(sourceViewDirection.x) > Math.abs(sourceViewDirection.z)) {
        return sourceViewDirection.x > 0 ? "0" : "2";
      } else {
        return sourceViewDirection.z > 0 ? "1" : "3";
      }
    })();

    // Replace blocks to correctly place the door
    dimension.runCommandAsync(`setblock ${location.x} ${location.y + 1} ${location.z} air replace`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y + 2} ${location.z} air replace`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y + 1} ${location.z} air replace`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y + 2} ${location.z} air replace`);
    dimension.runCommandAsync(`setblock ${location.x} ${location.y + 1} ${location.z} ${itemStack.typeId}["direction"=${direction}] replace`);
  }
});
