import { world, system } from '@minecraft/server';

world.afterEvents.itemUse.subscribe(event => {
    const player = event.source;
    const item = event.itemStack;

    // Ensure the player is not sneaking and the item used is an XP bottle
    if (player.isSneaking || item?.typeId !== "minecraft:experience_bottle") return;

    const location = player.location;

    // Function to summon additional XP bottles with a slight delay
    const summonXPBottles = (count = 0) => {
        if (count < 3) {
            const head = player.getHeadLocation();
                const view = player.getViewDirection();
                const bullet = player.dimension.spawnEntity('minecraft:xp_bottle', head);
                const proj = bullet.getComponent('projectile');
                proj.owner = player;
                proj.shoot({ x: view.x * 0.5, y: view.y * 0.2, z: view.z * 0.5 });
            system.runTimeout(() => summonXPBottles(count + 1), 2);
        }
    };

    summonXPBottles();

    // Remove 2 XP bottles from the player's inventory
    const inventory = player.getComponent("minecraft:inventory").container;
    for (let slot = 0; slot < inventory.size; slot++) {
        const slotItem = inventory.getItem(slot);
        if (slotItem && slotItem.typeId === "minecraft:experience_bottle") {
            if (slotItem.amount > 1) {
                slotItem.amount -= 1;
                inventory.setItem(slot, slotItem);
            } else {
                inventory.setItem(slot, undefined);
            }
            break; // Exit loop after updating the first found XP bottle stack
        }
    }
});
